SuperStrict

Import "src/TPlanet.bmx"
Import "src/T2DMap.bmx"

AppTitle = "Planet Generator"
Global gfx_w:Int = 800
Global gfx_h:Int = 600
Graphics(gfx_w, gfx_h, 0, 60)
AutoMidHandle(True)
SeedRnd MilliSecs()
Local Frametimer:TTimer = TTimer.Create(59)
SetBlend(ALPHABLEND)

Global mx:Int, my:Int, md:Int[4], mh:Int[4], key:Int[256], ms:Int

Local FontSmall:TImageFont = LoadImageFont(getenv_("windir") + "/fonts/" + "consola.ttf", 16)
Local FontBig:TImageFont = LoadImageFont(getenv_("windir") + "/fonts/" + "consola.ttf", 22)

Local viewmode:Int = 1
Local map2d:T2DMap = T2DMap.Create(64, 32) 'changing size may cause errors
map2d.Earth()

Local planet:TPlanet = New TPlanet.Create(map2d)

Local rotationManual:Float = 0.5
Local rotationAuto:Int = 0, rotationAutoX:Float = 0, rotationAutoY:Float = 0.3, rotationAutoZ:Float = 0

Repeat
	Cls
	getInputs()
	SetImageFont(Null)
	SetScale(1, 1)
	SetColor(230, 230, 230)

	DrawText("[space] changes viewmode", 10, 10)
	DrawText("[tab] autorotation", 10, 25)
	DrawText("[wasdqe] rotate", 10, 40)
	DrawText("[enter] generate new", 10, 55)
	DrawText("[F8] save", 10, 70)

	If key[KEY_SPACE] Then viewmode = (viewmode + 1) Mod 3
	If key[KEY_TAB] Then rotationAuto = rotationAuto ~ 1

	If key[KEY_F1] Then
		map2d.Earth()
		planet = New TPlanet.Create(map2d)
	EndIf
	If key[KEY_F2] Then
		map2d.Test()
		planet = New TPlanet.Create(map2d)
	EndIf
	If key[KEY_ENTER] Then
		map2d.Generate()
		planet = New TPlanet.Create(map2d)
	End If
	If key[KEY_F8] Then
		map2d.Save()
	End If

	If KeyDown(KEY_W) Then planet.Turn(rotationManual, 0, 0)
	If KeyDown(KEY_S) Then planet.Turn(-rotationManual, 0, 0)
	If KeyDown(KEY_A) Then planet.Turn(0, -rotationManual, 0)
	If KeyDown(KEY_D) Then planet.Turn(0, rotationManual, 0)
	If KeyDown(KEY_Q) Then planet.Turn(0, 0, rotationManual)
	If KeyDown(KEY_E) Then planet.Turn(0, 0, -rotationManual)

	Select viewmode
		Case 0
			SetImageFont(Null)
			map2d.Draw(80, gfx_h * 0.2)
		Case 1
			SetImageFont(FontBig)
			If rotationAuto Then planet.Turn(rotationAutoX, rotationAutoY, rotationAutoZ)
			planet.Draw(gfx_w / 2, gfx_h / 2, 250.0)
		Case 2
			SetImageFont(FontSmall)
			If rotationAuto Then planet.Turn(rotationAutoX, rotationAutoY, rotationAutoZ)
			planet.Draw(gfx_w / 2, gfx_h * 0.225, 130.0)
			SetImageFont(Null)
			SetScale(1, 1)
			map2d.Draw(80, gfx_h * 0.45)
	EndSelect


	Flip(0)
	Frametimer.Wait()
	If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
Forever
End

Function getInputs()
	ms = MilliSecs()
	mx = MouseX()
	my = MouseY()
	For Local i:Int = 1 Until mh.length
		mh[i] = MouseHit(i)
	Next
	For Local i:Int = 1 Until md.length
		md[i] = MouseDown(i)
	Next
	For Local i:Int = 0 Until key.length
		key[i] = KeyHit(i)
	Next
End Function

