SuperStrict

Rem
	TColor
Endrem

Type TColor
	Field a:Float, r:Int, g:Int, b:Int

	Method ToString:String()
		Return "$" + Hex(Byte(Self.a * 255.0) * $1000000 + Self.r * $10000 + Self.g * $100 + Self.b)
	End Method

	Method Use()
		SetColor(Self.r, Self.g, Self.b)
		SetAlpha(Self.a)
	End Method

	Method SetRGB(_r:Int, _g:Int, _b:Int)
		Self.r = _r
		Self.g = _g
		Self.b = _b
	End Method

	Function Create:TColor(_r:Int, _g:Int, _b:Int, _a:Float = 1.0)
		Local c:TColor = New TColor
		c.SetRGB(_r, _g, _b)
		c.a = _a
		Return c
	End Function

	Function CreateFromString:TColor(ARGB:String)
		If Not(ARGB.StartsWith("$")) Then ARGB = "$" + ARGB
		Select ARGB.Length
			Case 4 '* "$000" -> "$FF000000"
				ARGB = "$FF" + ARGB[1..2] + ARGB[1..2] + ..
				ARGB[2..3] + ARGB[2..3] + ..
				ARGB[3..] + ARGB[3..]
			Case 5 '* "$F000" -> "$FF000000"
				ARGB = "$" + ARGB[1..2] + ARGB[1..2] + ..
				ARGB[2..3] + ARGB[2..3] + ..
				ARGB[3..4] + ARGB[3..4] + ..
				ARGB[4..] + ARGB[4..]
			Case 7 '* "$000000"	-> "$FF000000"
				ARGB = "$FF" + ARGB[1..]
		EndSelect
		Local r:Int, g:Int, b:Int, a:Float
		Local argbI:Int = ARGB.ToInt()

		a = Byte((argbI & $FF000000) / $1000000) / 255.0
		r = (argbI & $FF0000) / $10000
		g = (argbI & $FF00) / $100
		b = argbI & $FF

		Return TColor.Create(r, g, b, a)
	End Function

	Function Clear()
		SetColor(255, 255, 255)
		SetAlpha(1.0)
	End Function

	Function Mix:TColor(_c1:TColor, _c2:TColor, _f:Float)
		Local fr:Float = 1.0 - _f
		Local R:Int = _c1.r * fr + _c2.r * _f
		Local G:Int = _c1.g * fr + _c2.g * _f
		Local B:Int = _c1.b * fr + _c2.b * _f
		Local A:Float = _c1.a * fr + _c2.a * _f

		Return TColor.Create(R, G, B, A)
	End Function

End Type
